@echo off

rem
rem  Illustration of UBL Code List Value Validation Methodology
rem
rem  $Id: test-all.bat,v 1.8 2006/06/18 17:02:52 G. Ken Holman Exp $
rem

if not exist ..\utility\UBL-ContextConstraints-0.6.xsd goto :nofile

echo Precondition validation...
echo.

echo Validating partner-agreed constraints...
echo   w3cschema UBL-ContextConstraints-0.6.xsd order-constraints.xml
call ..\utility\w3cschema ..\utility\UBL-ContextConstraints-0.6.xsd order-constraints.xml 2>&1 >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Validating code lists...
echo   w3cschema genericode-code-list-0.4.xsd MyCanadianProvinces.xml
call ..\utility\w3cschema ..\utility\genericode-code-list-0.4.xsd MyCanadianProvinces.gc 2>&1 >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error
echo   w3cschema genericode-code-list-0.4.xsd MyUSStates.xml
call ..\utility\w3cschema ..\utility\genericode-code-list-0.4.xsd MyUSStates.gc 2>&1 >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error
echo   w3cschema genericode-code-list-0.4.xsd MyCurrency.xml
call ..\utility\w3cschema ..\utility\genericode-code-list-0.4.xsd MyCurrencyLimits.gc 2>&1 >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Preparing code list rules...
echo.
echo Translating partner-agreed constraints into Schematron rules...
echo   xslt order-constraints.xml ..\utility\UBL-genericode2Schematron-0.6.xsl
echo                                                      order-constraints.sch
call ..\utility\xslt order-constraints.xml ..\utility\UBL-genericode2Schematron-0.6.xsl order-constraints.sch >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Test 1 - standalone code list rules
echo.
echo Assembling rules into a Schematron schema...
echo   xslt codes-only-constraints.sch ..\utility\schematron-ISO-assembly.xsl 
echo                                                      order-codes-only.sch
call ..\utility\xslt codes-only-constraints.sch ..\utility\schematron-ISO-assembly.xsl order-codes-only.sch >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Translating Schematron into validation stylesheet...
echo   xslt order-codes-only.sch ..\utility\schematron-ISO-incomplete-text.xsl 
echo                                                      order-codes-only.xsl
call ..\utility\xslt order-codes-only.sch ..\utility\schematron-ISO-incomplete-text.xsl order-codes-only.xsl >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Document validation...
echo.
echo Testing order-test-good1.xml...
echo   xslt order-test-good1.xml order-codes-only.xsl nul "2>test-constraints.txt"
call ..\utility\xslt order-test-good1.xml order-codes-only.xsl nul 2>test-constraints.txt
echo Result: %errorlevel%
type test-constraints.txt
echo.
echo.
echo Testing order-test-good2.xml...
echo   xslt order-test-good2.xml order-codes-only.xsl nul "2>test-constraints.txt"
call ..\utility\xslt order-test-good2.xml order-codes-only.xsl nul 2>test-constraints.txt   
echo Result: %errorlevel%
type test-constraints.txt
echo.
echo.
echo Testing order-test-bad1.xml...
echo   xslt order-test-bad1.xml order-codes-only.xsl nul "2>test-constraints.txt"
call ..\utility\xslt order-test-bad1.xml order-codes-only.xsl nul 2>test-constraints.txt
echo Result: %errorlevel%
type test-constraints.txt
echo.
echo.
echo Testing order-test-bad2.xml...
echo   xslt order-test-bad2.xml order-codes-only.xsl nul "2>test-constraints.txt"
call ..\utility\xslt order-test-bad2.xml order-codes-only.xsl nul 2>test-constraints.txt
echo Result: %errorlevel%
type test-constraints.txt
echo.
echo.
echo Testing order-test-bad3.xml...
echo   xslt order-test-bad3.xml order-codes-only.xsl nul "2>test-constraints.txt"
call ..\utility\xslt order-test-bad3.xml order-codes-only.xsl nul 2>test-constraints.txt
echo Result: %errorlevel%
type test-constraints.txt
echo.

echo.
echo Test 2 - with business rules
echo.
echo Assembling rules into a Schematron schema...
echo   xslt total-constraints.sch ..\utility\schematron-ISO-assembly.xsl 
echo                                                      order-codes-total.xsl
call ..\utility\xslt total-constraints.sch ..\utility\schematron-ISO-assembly.xsl order-codes-total.sch >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Translating Schematron into validation stylesheet...
echo   xslt order-codes-total.sch ..\utility\schematron-ISO-incomplete-text.xsl 
echo                                                      order-codes-total.xsl
call ..\utility\xslt order-codes-total.sch ..\utility\schematron-ISO-incomplete-text.xsl order-codes-total.xsl >test-constraints.txt
type test-constraints.txt
if %errorlevel% neq 0 goto :error

echo.
echo Document validation...
echo.
echo Testing order-test-bad3.xml...
echo   xslt order-test-bad3.xml order-codes-total.xsl nul "2>test-constraints.txt"
call ..\utility\xslt order-test-bad3.xml order-codes-total.xsl nul 2>test-constraints.txt
echo Result: %errorlevel%
type test-constraints.txt
echo.

echo.
echo Done.
goto :done

:nofile
echo.
echo Document model for constraints not found: ..\utility\UBL-ContextConstraints-0.6.xsd
goto :done

:error
type test-constraints.txt
echo.
echo Error; process terminated!
goto :done

:done
