#
#  Illustration of UBL Code List Value Validation Methodology
#  
#  $Id: test-all.sh,v 1.7 2006/06/18 17:02:52 G. Ken Holman Exp $
#

echo Precondition validation...
echo
echo Validating partner-agreed constraints...
echo :  w3cschema UBL-ContextConstraints-0.6.xsd order-constraints.xml
sh ../utility/w3cschema.sh ../utility/UBL-ContextConstraints-0.6.xsd order-constraints.xml 2>&1 >test-constraints.txt
cat test-constraints.txt
echo
echo Validating code lists...
echo   w3cschema genericode-code-list-0.4.xsd MyCanadianProvinces.gc
sh ../utility/w3cschema.sh ../utility/genericode-code-list-0.4.xsd MyCanadianProvinces.gc 2>&1 >test-constraints.txt
cat test-constraints.txt
echo   w3cschema genericode-code-list-0.4.xsd MyUSStates.gc
sh ../utility/w3cschema.sh ../utility/genericode-code-list-0.4.xsd MyUSStates.gc 2>&1 >test-constraints.txt
cat test-constraints.txt
echo   w3cschema.sh genericode-code-list-0.4.xsd MyCurrencyLimits.gc
sh ../utility/w3cschema.sh ../utility/genericode-code-list-0.4.xsd MyCurrencyLimits.gc 2>&1 >test-constraints.txt
cat test-constraints.txt
echo
echo Preparing code list rules...
echo
echo Translating partner-agreed constraints into Schematron ...
echo :  xslt order-constraints.xml ../utility/UBL-genericode2Schematron-0.6.xsl
echo :                                                    order-constraints.sch
sh ../utility/xslt.sh order-constraints.xml ../utility/UBL-genericode2Schematron-0.6.xsl order-constraints.sch >test-constraints.txt
echo
echo Test 1 - standalone code list rules
echo
echo Assembling rules into a Schematron schema...
echo :  xslt codes-only-constraints.sch ../utility/schematron-ISO-assembly.xsl 
echo                                                      order-codes-only.sch
sh ../utility/xslt.sh codes-only-constraints.sch ../utility/schematron-ISO-assembly.xsl order-codes-only.sch >test-constraints.txt
echo
echo Translating Schematron into validation stylesheet...
echo :  xslt order-codes-only.sch ../utility/schematron-ISO-incomplete-text.xsl 
echo                                                      order-codes-only.xsl
sh ../utility/xslt.sh order-codes-only.sch ../utility/schematron-ISO-incomplete-text.xsl order-codes-only.xsl >test-constraints.txt
echo
echo Document validation...
echo
echo Testing order-test-good1.xml...
echo :   xslt order-test-good1.xml order-codes-only.xsl /dev/null test-constraints.txt
sh ../utility/xslt.sh order-test-good1.xml order-codes-only.xsl /dev/null 2>test-constraints.txt
echo Result: $?
cat test-constraints.txt
echo
echo
echo Testing order-test-good2.xml...
echo :   xslt order-test-good2.xml order-codes-only.xsl /dev/null test-constraints.txt
sh ../utility/xslt.sh order-test-good2.xml order-codes-only.xsl /dev/null 2>test-constraints.txt   
echo Result: $?
cat test-constraints.txt
echo
echo
echo Testing order-test-bad1.xml...
echo :   xslt order-test-bad1.xml order-codes-only.xsl /dev/null test-constraints.txt
sh ../utility/xslt.sh order-test-bad1.xml order-codes-only.xsl /dev/null 2>test-constraints.txt
echo Result: $?
cat test-constraints.txt
echo
echo
echo Testing order-test-bad2.xml...
echo :   xslt order-test-bad2.xml order-codes-only.xsl /dev/null test-constraints.txt
sh ../utility/xslt.sh order-test-bad2.xml order-codes-only.xsl /dev/null 2>test-constraints.txt
echo Result: $?
cat test-constraints.txt
echo
echo
echo Testing order-test-bad3.xml...
echo :   xslt order-test-bad3.xml order-codes-only.xsl /dev/null test-constraints.txt
sh ../utility/xslt.sh order-test-bad3.xml order-codes-only.xsl /dev/null 2>test-constraints.txt
echo Result: $?
cat test-constraints.txt
echo
echo
echo
echo Test 2 - with business rules
echo
echo Assembling rules into a Schematron schema...
echo :  xslt total-constraints.sch ../utility/schematron-ISO-assembly.xsl 
echo                                                      order-codes-total.sch
sh ../utility/xslt.sh total-constraints.sch ../utility/schematron-ISO-assembly.xsl order-codes-total.sch >test-constraints.txt
echo
echo Translating Schematron into validation stylesheet...
echo   xslt order-codes-total.sch ../utility/schematron-ISO-incomplete-text.xsl 
echo                                                      order-codes-total.xsl
sh ../utility/xslt.sh order-codes-total.sch ../utility/schematron-ISO-incomplete-text.xsl order-codes-total.xsl >test-constraints.txt
echo
echo Document validation...
echo
echo
echo Testing order-test-bad3.xml...
echo :   xslt order-test-bad3.xml order-codes-total.xsl /dev/null test-constraints.txt
sh ../utility/xslt.sh order-test-bad3.xml order-codes-total.xsl /dev/null 2>test-constraints.txt
echo Result: $?
cat test-constraints.txt
echo
echo
